/* game.c generated by valac 0.22.0.43-7c3715, the Vala compiler
 * generated from game.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;

#define TYPE_PLAYER (player_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

typedef enum  {
	PLAYER_NONE,
	PLAYER_LIGHT,
	PLAYER_DARK
} Player;

struct _GamePrivate {
	Player* tiles;
	gint tiles_length1;
	gint tiles_length2;
	gint undo_history[1344];
	gint undo_index;
	Player _current_color;
};


static gpointer game_parent_class = NULL;

GType game_get_type (void) G_GNUC_CONST;
GType player_get_type (void) G_GNUC_CONST;
#define GAME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_GAME, GamePrivate))
enum  {
	GAME_DUMMY_PROPERTY,
	GAME_WIDTH,
	GAME_HEIGHT,
	GAME_CURRENT_COLOR,
	GAME_N_TILES,
	GAME_N_LIGHT_TILES,
	GAME_N_DARK_TILES
};
Game* game_new (gint width, gint height);
Game* game_construct (GType object_type, gint width, gint height);
static void game_set_tile (Game* self, gint x, gint y, Player color, gboolean update_history);
static void game_set_current_color (Game* self, Player value);
Game* game_new_from_strings (gchar** setup, int setup_length1, Player to_move, gint width, gint height);
Game* game_construct_from_strings (GType object_type, gchar** setup, int setup_length1, Player to_move, gint width, gint height);
Player player_from_char (gchar c);
gchar* game_to_string (Game* self);
Game* game_new_copy (Game* game);
Game* game_construct_copy (GType object_type, Game* game);
gint game_get_width (Game* self);
gint game_get_height (Game* self);
Player game_get_current_color (Game* self);
Player game_get_owner (Game* self, gint x, gint y);
static gboolean game_is_valid_location (Game* self, gint x, gint y);
gboolean game_is_complete (Game* self);
gboolean game_can_move (Game* self, Player color);
gint game_get_n_tiles (Game* self);
gboolean game_can_place (Game* self, gint x, gint y, Player color);
static gint game_place (Game* self, gint x, gint y, Player color, gboolean apply);
gint game_place_tile (Game* self, gint x, gint y);
Player player_flip_color (Player p);
void game_pass (Game* self);
static gint game_flip_tiles (Game* self, gint x, gint y, gint x_step, gint y_step, Player color, gboolean apply);
gint game_count_tiles (Game* self, Player color);
gboolean game_can_undo (Game* self);
void game_undo (Game* self, gint count);
gchar* player_to_string (Player self);
gint game_get_n_light_tiles (Game* self);
gint game_get_n_dark_tiles (Game* self);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void game_finalize (GObject* obj);
static void _vala_game_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_game_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


Game* game_construct (GType object_type, gint width, gint height) {
	Game * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Player* _tmp2_ = NULL;
#line 62 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self = (Game*) g_object_new (object_type, NULL);
#line 65 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = width;
#line 65 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = height;
#line 65 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = g_new0 (Player, _tmp0_ * _tmp1_);
#line 65 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles = (g_free (self->priv->tiles), NULL);
#line 65 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles = _tmp2_;
#line 65 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles_length1 = _tmp0_;
#line 65 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles_length2 = _tmp1_;
#line 131 "game.c"
	{
		gint x = 0;
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		x = 0;
#line 136 "game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			_tmp3_ = TRUE;
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			while (TRUE) {
#line 143 "game.c"
				gboolean _tmp4_ = FALSE;
				gint _tmp6_ = 0;
				gint _tmp7_ = 0;
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp4_ = _tmp3_;
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!_tmp4_) {
#line 151 "game.c"
					gint _tmp5_ = 0;
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp5_ = x;
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					x = _tmp5_ + 1;
#line 157 "game.c"
				}
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp3_ = FALSE;
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp6_ = x;
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp7_ = width;
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!(_tmp6_ < _tmp7_)) {
#line 66 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					break;
#line 169 "game.c"
				}
				{
					gint y = 0;
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					y = 0;
#line 175 "game.c"
					{
						gboolean _tmp8_ = FALSE;
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						_tmp8_ = TRUE;
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						while (TRUE) {
#line 182 "game.c"
							gboolean _tmp9_ = FALSE;
							gint _tmp11_ = 0;
							gint _tmp12_ = 0;
							Player* _tmp13_ = NULL;
							gint _tmp13__length1 = 0;
							gint _tmp13__length2 = 0;
							gint _tmp14_ = 0;
							gint _tmp15_ = 0;
							Player _tmp16_ = 0;
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp9_ = _tmp8_;
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!_tmp9_) {
#line 196 "game.c"
								gint _tmp10_ = 0;
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								_tmp10_ = y;
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								y = _tmp10_ + 1;
#line 202 "game.c"
							}
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp8_ = FALSE;
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp11_ = y;
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp12_ = height;
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!(_tmp11_ < _tmp12_)) {
#line 67 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								break;
#line 214 "game.c"
							}
#line 68 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp13_ = self->priv->tiles;
#line 68 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp13__length1 = self->priv->tiles_length1;
#line 68 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp13__length2 = self->priv->tiles_length2;
#line 68 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp14_ = x;
#line 68 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp15_ = y;
#line 68 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp13_[(_tmp14_ * _tmp13__length2) + _tmp15_] = PLAYER_NONE;
#line 68 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp16_ = _tmp13_[(_tmp14_ * _tmp13__length2) + _tmp15_];
#line 230 "game.c"
						}
					}
				}
			}
		}
	}
#line 69 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	game_set_tile (self, 3, 3, PLAYER_LIGHT, FALSE);
#line 70 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	game_set_tile (self, 3, 4, PLAYER_DARK, FALSE);
#line 71 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	game_set_tile (self, 4, 3, PLAYER_DARK, FALSE);
#line 72 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	game_set_tile (self, 4, 4, PLAYER_LIGHT, FALSE);
#line 75 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	game_set_current_color (self, PLAYER_DARK);
#line 62 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return self;
#line 249 "game.c"
}


Game* game_new (gint width, gint height) {
#line 62 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return game_construct (TYPE_GAME, width, height);
#line 256 "game.c"
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_ = 0L;
	gchar _tmp1_ = '\0';
#line 965 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 966 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 966 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 966 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 966 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	return result;
#line 274 "game.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 1084 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1085 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1085 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1086 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1086 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1087 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	result = _result_;
#line 1087 "/home/mcatanzaro/jhbuild/install/share/vala-0.24/vapi/glib-2.0.vapi"
	return result;
#line 297 "game.c"
}


Game* game_construct_from_strings (GType object_type, gchar** setup, int setup_length1, Player to_move, gint width, gint height) {
	Game * self = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp1_ = 0;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	const gchar* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	Player* _tmp9_ = NULL;
	Player _tmp30_ = 0;
	gchar** _tmp31_ = NULL;
	gint _tmp31__length1 = 0;
	gchar* _tmp32_ = NULL;
	gchar* _tmp33_ = NULL;
	gchar* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	gchar* _tmp36_ = NULL;
	gchar* _tmp37_ = NULL;
	gchar* _tmp38_ = NULL;
	gchar* _tmp39_ = NULL;
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = setup;
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0__length1 = setup_length1;
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = height;
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (_tmp0__length1 == _tmp1_, NULL);
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = setup;
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2__length1 = setup_length1;
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp3_ = _tmp2_[0];
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp4_ = strlen (_tmp3_);
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp5_ = _tmp4_;
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp6_ = width;
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (_tmp5_ == _tmp6_, NULL);
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self = (Game*) g_object_new (object_type, NULL);
#line 82 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp7_ = width;
#line 82 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp8_ = height;
#line 82 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp9_ = g_new0 (Player, _tmp7_ * _tmp8_);
#line 82 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles = (g_free (self->priv->tiles), NULL);
#line 82 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles = _tmp9_;
#line 82 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles_length1 = _tmp7_;
#line 82 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles_length2 = _tmp8_;
#line 364 "game.c"
	{
		gint y = 0;
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		y = 0;
#line 369 "game.c"
		{
			gboolean _tmp10_ = FALSE;
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			_tmp10_ = TRUE;
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			while (TRUE) {
#line 376 "game.c"
				gboolean _tmp11_ = FALSE;
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp11_ = _tmp10_;
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!_tmp11_) {
#line 384 "game.c"
					gint _tmp12_ = 0;
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp12_ = y;
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					y = _tmp12_ + 1;
#line 390 "game.c"
				}
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp10_ = FALSE;
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp13_ = y;
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp14_ = height;
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 84 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					break;
#line 402 "game.c"
				}
				{
					gint x = 0;
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					x = 0;
#line 408 "game.c"
					{
						gboolean _tmp15_ = FALSE;
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						_tmp15_ = TRUE;
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						while (TRUE) {
#line 415 "game.c"
							gboolean _tmp16_ = FALSE;
							gint _tmp18_ = 0;
							gint _tmp19_ = 0;
							Player* _tmp20_ = NULL;
							gint _tmp20__length1 = 0;
							gint _tmp20__length2 = 0;
							gint _tmp21_ = 0;
							gint _tmp22_ = 0;
							gchar** _tmp23_ = NULL;
							gint _tmp23__length1 = 0;
							gint _tmp24_ = 0;
							const gchar* _tmp25_ = NULL;
							gint _tmp26_ = 0;
							gchar _tmp27_ = '\0';
							Player _tmp28_ = 0;
							Player _tmp29_ = 0;
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp16_ = _tmp15_;
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!_tmp16_) {
#line 436 "game.c"
								gint _tmp17_ = 0;
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								_tmp17_ = x;
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								x = _tmp17_ + 1;
#line 442 "game.c"
							}
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp15_ = FALSE;
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp18_ = x;
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp19_ = width;
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!(_tmp18_ < _tmp19_)) {
#line 85 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								break;
#line 454 "game.c"
							}
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp20_ = self->priv->tiles;
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp20__length1 = self->priv->tiles_length1;
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp20__length2 = self->priv->tiles_length2;
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp21_ = x;
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp22_ = y;
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp23_ = setup;
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp23__length1 = setup_length1;
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp24_ = y;
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp25_ = _tmp23_[_tmp24_];
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp26_ = x;
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp27_ = string_get (_tmp25_, (glong) _tmp26_);
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp28_ = player_from_char (_tmp27_);
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp20_[(_tmp21_ * _tmp20__length2) + _tmp22_] = _tmp28_;
#line 86 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp29_ = _tmp20_[(_tmp21_ * _tmp20__length2) + _tmp22_];
#line 484 "game.c"
						}
					}
				}
			}
		}
	}
#line 88 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp30_ = to_move;
#line 88 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	game_set_current_color (self, _tmp30_);
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp31_ = setup;
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp31__length1 = setup_length1;
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp32_ = g_strjoinv ("\n", _tmp31_);
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp33_ = _tmp32_;
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp34_ = string_strip (_tmp33_);
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp35_ = _tmp34_;
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp36_ = game_to_string (self);
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp37_ = _tmp36_;
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp38_ = string_strip (_tmp37_);
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp39_ = _tmp38_;
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_warn_if_fail (g_strcmp0 (_tmp35_, _tmp39_) == 0);
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_g_free0 (_tmp39_);
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_g_free0 (_tmp37_);
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_g_free0 (_tmp35_);
#line 90 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_g_free0 (_tmp33_);
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return self;
#line 527 "game.c"
}


Game* game_new_from_strings (gchar** setup, int setup_length1, Player to_move, gint width, gint height) {
#line 78 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return game_construct_from_strings (TYPE_GAME, setup, setup_length1, to_move, width, height);
#line 534 "game.c"
}


Game* game_construct_copy (GType object_type, Game* game) {
	Game * self = NULL;
	Game* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	Game* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	Player* _tmp6_ = NULL;
	Game* _tmp39_ = NULL;
	gint _tmp40_ = 0;
	Game* _tmp41_ = NULL;
	Player _tmp42_ = 0;
#line 93 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 93 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self = (Game*) g_object_new (object_type, NULL);
#line 95 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = game;
#line 95 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = game_get_width (_tmp0_);
#line 95 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = _tmp1_;
#line 95 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp3_ = game;
#line 95 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp4_ = game_get_height (_tmp3_);
#line 95 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp5_ = _tmp4_;
#line 95 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp6_ = g_new0 (Player, _tmp2_ * _tmp5_);
#line 95 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles = (g_free (self->priv->tiles), NULL);
#line 95 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles = _tmp6_;
#line 95 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles_length1 = _tmp2_;
#line 95 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles_length2 = _tmp5_;
#line 577 "game.c"
	{
		gint x = 0;
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		x = 0;
#line 582 "game.c"
		{
			gboolean _tmp7_ = FALSE;
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			_tmp7_ = TRUE;
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			while (TRUE) {
#line 589 "game.c"
				gboolean _tmp8_ = FALSE;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				gint _tmp12_ = 0;
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp8_ = _tmp7_;
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!_tmp8_) {
#line 598 "game.c"
					gint _tmp9_ = 0;
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp9_ = x;
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					x = _tmp9_ + 1;
#line 604 "game.c"
				}
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp7_ = FALSE;
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp10_ = x;
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp11_ = game_get_width (self);
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp12_ = _tmp11_;
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!(_tmp10_ < _tmp12_)) {
#line 96 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					break;
#line 618 "game.c"
				}
				{
					gint y = 0;
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					y = 0;
#line 624 "game.c"
					{
						gboolean _tmp13_ = FALSE;
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						_tmp13_ = TRUE;
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						while (TRUE) {
#line 631 "game.c"
							gboolean _tmp14_ = FALSE;
							gint _tmp16_ = 0;
							gint _tmp17_ = 0;
							gint _tmp18_ = 0;
							Player* _tmp19_ = NULL;
							gint _tmp19__length1 = 0;
							gint _tmp19__length2 = 0;
							gint _tmp20_ = 0;
							gint _tmp21_ = 0;
							Game* _tmp22_ = NULL;
							Player* _tmp23_ = NULL;
							gint _tmp23__length1 = 0;
							gint _tmp23__length2 = 0;
							gint _tmp24_ = 0;
							gint _tmp25_ = 0;
							Player _tmp26_ = 0;
							Player _tmp27_ = 0;
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp14_ = _tmp13_;
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!_tmp14_) {
#line 653 "game.c"
								gint _tmp15_ = 0;
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								_tmp15_ = y;
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								y = _tmp15_ + 1;
#line 659 "game.c"
							}
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp13_ = FALSE;
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp16_ = y;
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp17_ = game_get_height (self);
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp18_ = _tmp17_;
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!(_tmp16_ < _tmp18_)) {
#line 97 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								break;
#line 673 "game.c"
							}
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp19_ = self->priv->tiles;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp19__length1 = self->priv->tiles_length1;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp19__length2 = self->priv->tiles_length2;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp20_ = x;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp21_ = y;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp22_ = game;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp23_ = _tmp22_->priv->tiles;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp23__length1 = _tmp22_->priv->tiles_length1;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp23__length2 = _tmp22_->priv->tiles_length2;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp24_ = x;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp25_ = y;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp26_ = _tmp23_[(_tmp24_ * _tmp23__length2) + _tmp25_];
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp19_[(_tmp20_ * _tmp19__length2) + _tmp21_] = _tmp26_;
#line 98 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp27_ = _tmp19_[(_tmp20_ * _tmp19__length2) + _tmp21_];
#line 703 "game.c"
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		i = 0;
#line 714 "game.c"
		{
			gboolean _tmp28_ = FALSE;
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			_tmp28_ = TRUE;
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			while (TRUE) {
#line 721 "game.c"
				gboolean _tmp29_ = FALSE;
				gint _tmp31_ = 0;
				Game* _tmp32_ = NULL;
				gint _tmp33_ = 0;
				gint _tmp34_ = 0;
				Game* _tmp35_ = NULL;
				gint _tmp36_ = 0;
				gint _tmp37_ = 0;
				gint _tmp38_ = 0;
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp29_ = _tmp28_;
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!_tmp29_) {
#line 735 "game.c"
					gint _tmp30_ = 0;
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp30_ = i;
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					i = _tmp30_ + 1;
#line 741 "game.c"
				}
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp28_ = FALSE;
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp31_ = i;
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp32_ = game;
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp33_ = _tmp32_->priv->undo_index;
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!(_tmp31_ < _tmp33_)) {
#line 99 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					break;
#line 755 "game.c"
				}
#line 100 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp34_ = i;
#line 100 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp35_ = game;
#line 100 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp36_ = i;
#line 100 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp37_ = _tmp35_->priv->undo_history[_tmp36_];
#line 100 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				self->priv->undo_history[_tmp34_] = _tmp37_;
#line 100 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp38_ = self->priv->undo_history[_tmp34_];
#line 769 "game.c"
			}
		}
	}
#line 101 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp39_ = game;
#line 101 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp40_ = _tmp39_->priv->undo_index;
#line 101 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->undo_index = _tmp40_;
#line 102 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp41_ = game;
#line 102 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp42_ = _tmp41_->priv->_current_color;
#line 102 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	game_set_current_color (self, _tmp42_);
#line 93 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return self;
#line 787 "game.c"
}


Game* game_new_copy (Game* game) {
#line 93 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return game_construct_copy (TYPE_GAME, game);
#line 794 "game.c"
}


Player game_get_owner (Game* self, gint x, gint y) {
	Player result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
#line 105 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 107 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = x;
#line 107 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = y;
#line 107 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = game_is_valid_location (self, _tmp0_, _tmp1_);
#line 107 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp2_) {
#line 813 "game.c"
		Player* _tmp3_ = NULL;
		gint _tmp3__length1 = 0;
		gint _tmp3__length2 = 0;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		Player _tmp6_ = 0;
#line 108 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp3_ = self->priv->tiles;
#line 108 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp3__length1 = self->priv->tiles_length1;
#line 108 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp3__length2 = self->priv->tiles_length2;
#line 108 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp4_ = x;
#line 108 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp5_ = y;
#line 108 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp6_ = _tmp3_[(_tmp4_ * _tmp3__length2) + _tmp5_];
#line 108 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		result = _tmp6_;
#line 108 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		return result;
#line 836 "game.c"
	} else {
#line 110 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		result = PLAYER_NONE;
#line 110 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		return result;
#line 842 "game.c"
	}
}


gboolean game_is_complete (Game* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gboolean _tmp11_ = FALSE;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
#line 113 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = game_can_move (self, PLAYER_LIGHT);
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (!_tmp1_) {
#line 872 "game.c"
		gboolean _tmp2_ = FALSE;
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp2_ = game_can_move (self, PLAYER_DARK);
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp0_ = !_tmp2_;
#line 878 "game.c"
	} else {
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp0_ = FALSE;
#line 882 "game.c"
	}
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp3_ = _tmp0_;
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = _tmp3_;
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp4_ = result;
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp5_ = game_get_n_tiles (self);
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp6_ = _tmp5_;
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp7_ = game_get_width (self);
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp8_ = _tmp7_;
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp9_ = game_get_height (self);
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp10_ = _tmp9_;
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_warn_if_fail (_tmp4_ || (_tmp6_ < (_tmp8_ * _tmp10_)));
#line 116 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 906 "game.c"
}


gboolean game_can_move (Game* self, Player color) {
	gboolean result = FALSE;
#line 119 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 914 "game.c"
	{
		gint x = 0;
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		x = 0;
#line 919 "game.c"
		{
			gboolean _tmp0_ = FALSE;
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			_tmp0_ = TRUE;
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			while (TRUE) {
#line 926 "game.c"
				gboolean _tmp1_ = FALSE;
				gint _tmp3_ = 0;
				gint _tmp4_ = 0;
				gint _tmp5_ = 0;
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp1_ = _tmp0_;
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!_tmp1_) {
#line 935 "game.c"
					gint _tmp2_ = 0;
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp2_ = x;
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					x = _tmp2_ + 1;
#line 941 "game.c"
				}
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp0_ = FALSE;
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp3_ = x;
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp4_ = game_get_width (self);
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp5_ = _tmp4_;
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!(_tmp3_ < _tmp5_)) {
#line 121 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					break;
#line 955 "game.c"
				}
				{
					gint y = 0;
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					y = 0;
#line 961 "game.c"
					{
						gboolean _tmp6_ = FALSE;
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						_tmp6_ = TRUE;
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						while (TRUE) {
#line 968 "game.c"
							gboolean _tmp7_ = FALSE;
							gint _tmp9_ = 0;
							gint _tmp10_ = 0;
							gint _tmp11_ = 0;
							gint _tmp12_ = 0;
							gint _tmp13_ = 0;
							Player _tmp14_ = 0;
							gboolean _tmp15_ = FALSE;
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp7_ = _tmp6_;
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!_tmp7_) {
#line 981 "game.c"
								gint _tmp8_ = 0;
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								_tmp8_ = y;
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								y = _tmp8_ + 1;
#line 987 "game.c"
							}
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp6_ = FALSE;
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp9_ = y;
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp10_ = game_get_height (self);
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp11_ = _tmp10_;
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!(_tmp9_ < _tmp11_)) {
#line 122 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								break;
#line 1001 "game.c"
							}
#line 123 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp12_ = x;
#line 123 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp13_ = y;
#line 123 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp14_ = color;
#line 123 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp15_ = game_can_place (self, _tmp12_, _tmp13_, _tmp14_);
#line 123 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (_tmp15_) {
#line 124 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								result = TRUE;
#line 124 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								return result;
#line 1017 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 125 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = FALSE;
#line 125 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 1029 "game.c"
}


gboolean game_can_place (Game* self, gint x, gint y, Player color) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Player _tmp2_ = 0;
	gint _tmp3_ = 0;
#line 128 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 130 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = x;
#line 130 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = y;
#line 130 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = color;
#line 130 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp3_ = game_place (self, _tmp0_, _tmp1_, _tmp2_, FALSE);
#line 130 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = _tmp3_ > 0;
#line 130 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 1053 "game.c"
}


gint game_place_tile (Game* self, gint x, gint y) {
	gint result = 0;
	gint n_tiles = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Player _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	Player _tmp5_ = 0;
	Player _tmp6_ = 0;
	gboolean _tmp7_ = FALSE;
#line 133 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 135 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = x;
#line 135 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = y;
#line 135 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = self->priv->_current_color;
#line 135 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp3_ = game_place (self, _tmp0_, _tmp1_, _tmp2_, TRUE);
#line 135 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	n_tiles = _tmp3_;
#line 136 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp4_ = n_tiles;
#line 136 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp4_ == 0) {
#line 137 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		result = 0;
#line 137 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		return result;
#line 1088 "game.c"
	}
#line 139 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp5_ = self->priv->_current_color;
#line 139 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp6_ = player_flip_color (_tmp5_);
#line 139 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	game_set_current_color (self, _tmp6_);
#line 141 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp7_ = game_is_complete (self);
#line 141 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp7_) {
#line 142 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		g_signal_emit_by_name (self, "complete");
#line 1102 "game.c"
	} else {
#line 144 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		g_signal_emit_by_name (self, "move");
#line 1106 "game.c"
	}
#line 146 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = n_tiles;
#line 146 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 1112 "game.c"
}


void game_pass (Game* self) {
	Player _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	Player _tmp5_ = 0;
	Player _tmp6_ = 0;
#line 149 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_if_fail (self != NULL);
#line 149 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = self->priv->_current_color;
#line 149 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = game_can_move (self, _tmp0_);
#line 149 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_if_fail (!_tmp1_);
#line 152 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = self->priv->undo_index;
#line 152 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->undo_history[_tmp2_] = 0;
#line 152 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp3_ = self->priv->undo_history[_tmp2_];
#line 153 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp4_ = self->priv->undo_index;
#line 153 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->undo_index = _tmp4_ + 1;
#line 154 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp5_ = self->priv->_current_color;
#line 154 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp6_ = player_flip_color (_tmp5_);
#line 154 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	game_set_current_color (self, _tmp6_);
#line 155 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_signal_emit_by_name (self, "move");
#line 1150 "game.c"
}


static gint game_place (Game* self, gint x, gint y, Player color, gboolean apply) {
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gint n_flips = 0;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	Player _tmp12_ = 0;
	gboolean _tmp13_ = FALSE;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	Player _tmp18_ = 0;
	gboolean _tmp19_ = FALSE;
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	Player _tmp24_ = 0;
	gboolean _tmp25_ = FALSE;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	Player _tmp30_ = 0;
	gboolean _tmp31_ = FALSE;
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	gint _tmp34_ = 0;
	gint _tmp35_ = 0;
	Player _tmp36_ = 0;
	gboolean _tmp37_ = FALSE;
	gint _tmp38_ = 0;
	gint _tmp39_ = 0;
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	Player _tmp42_ = 0;
	gboolean _tmp43_ = FALSE;
	gint _tmp44_ = 0;
	gint _tmp45_ = 0;
	gint _tmp46_ = 0;
	gint _tmp47_ = 0;
	Player _tmp48_ = 0;
	gboolean _tmp49_ = FALSE;
	gint _tmp50_ = 0;
	gint _tmp51_ = 0;
	gint _tmp52_ = 0;
	gint _tmp53_ = 0;
	Player _tmp54_ = 0;
	gboolean _tmp55_ = FALSE;
	gint _tmp56_ = 0;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gboolean _tmp60_ = FALSE;
#line 158 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = x;
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = y;
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp3_ = game_is_valid_location (self, _tmp1_, _tmp2_);
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (!_tmp3_) {
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp0_ = TRUE;
#line 1225 "game.c"
	} else {
		Player* _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		gint _tmp4__length2 = 0;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		Player _tmp7_ = 0;
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp4_ = self->priv->tiles;
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp4__length1 = self->priv->tiles_length1;
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp4__length2 = self->priv->tiles_length2;
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp5_ = x;
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp6_ = y;
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp7_ = _tmp4_[(_tmp5_ * _tmp4__length2) + _tmp6_];
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp0_ = _tmp7_ != PLAYER_NONE;
#line 1247 "game.c"
	}
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp8_ = _tmp0_;
#line 161 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp8_) {
#line 162 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		result = 0;
#line 162 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		return result;
#line 1257 "game.c"
	}
#line 164 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	n_flips = 0;
#line 165 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp9_ = n_flips;
#line 165 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp10_ = x;
#line 165 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp11_ = y;
#line 165 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp12_ = color;
#line 165 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp13_ = apply;
#line 165 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp14_ = game_flip_tiles (self, _tmp10_, _tmp11_, 1, 0, _tmp12_, _tmp13_);
#line 165 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	n_flips = _tmp9_ + _tmp14_;
#line 166 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp15_ = n_flips;
#line 166 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp16_ = x;
#line 166 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp17_ = y;
#line 166 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp18_ = color;
#line 166 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp19_ = apply;
#line 166 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp20_ = game_flip_tiles (self, _tmp16_, _tmp17_, 1, 1, _tmp18_, _tmp19_);
#line 166 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	n_flips = _tmp15_ + _tmp20_;
#line 167 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp21_ = n_flips;
#line 167 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp22_ = x;
#line 167 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp23_ = y;
#line 167 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp24_ = color;
#line 167 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp25_ = apply;
#line 167 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp26_ = game_flip_tiles (self, _tmp22_, _tmp23_, 0, 1, _tmp24_, _tmp25_);
#line 167 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	n_flips = _tmp21_ + _tmp26_;
#line 168 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp27_ = n_flips;
#line 168 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp28_ = x;
#line 168 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp29_ = y;
#line 168 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp30_ = color;
#line 168 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp31_ = apply;
#line 168 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp32_ = game_flip_tiles (self, _tmp28_, _tmp29_, -1, 1, _tmp30_, _tmp31_);
#line 168 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	n_flips = _tmp27_ + _tmp32_;
#line 169 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp33_ = n_flips;
#line 169 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp34_ = x;
#line 169 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp35_ = y;
#line 169 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp36_ = color;
#line 169 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp37_ = apply;
#line 169 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp38_ = game_flip_tiles (self, _tmp34_, _tmp35_, -1, 0, _tmp36_, _tmp37_);
#line 169 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	n_flips = _tmp33_ + _tmp38_;
#line 170 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp39_ = n_flips;
#line 170 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp40_ = x;
#line 170 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp41_ = y;
#line 170 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp42_ = color;
#line 170 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp43_ = apply;
#line 170 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp44_ = game_flip_tiles (self, _tmp40_, _tmp41_, -1, -1, _tmp42_, _tmp43_);
#line 170 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	n_flips = _tmp39_ + _tmp44_;
#line 171 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp45_ = n_flips;
#line 171 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp46_ = x;
#line 171 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp47_ = y;
#line 171 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp48_ = color;
#line 171 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp49_ = apply;
#line 171 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp50_ = game_flip_tiles (self, _tmp46_, _tmp47_, 0, -1, _tmp48_, _tmp49_);
#line 171 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	n_flips = _tmp45_ + _tmp50_;
#line 172 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp51_ = n_flips;
#line 172 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp52_ = x;
#line 172 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp53_ = y;
#line 172 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp54_ = color;
#line 172 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp55_ = apply;
#line 172 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp56_ = game_flip_tiles (self, _tmp52_, _tmp53_, 1, -1, _tmp54_, _tmp55_);
#line 172 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	n_flips = _tmp51_ + _tmp56_;
#line 175 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp58_ = apply;
#line 175 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp58_) {
#line 1377 "game.c"
		gint _tmp59_ = 0;
#line 175 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp59_ = n_flips;
#line 175 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp57_ = _tmp59_ > 0;
#line 1383 "game.c"
	} else {
#line 175 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp57_ = FALSE;
#line 1387 "game.c"
	}
#line 175 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp60_ = _tmp57_;
#line 175 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp60_) {
#line 1393 "game.c"
		gint _tmp61_ = 0;
		gint _tmp62_ = 0;
		gint _tmp63_ = 0;
		gint _tmp64_ = 0;
#line 177 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp61_ = self->priv->undo_index;
#line 177 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp62_ = n_flips;
#line 177 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		self->priv->undo_history[_tmp61_] = _tmp62_ + 1;
#line 177 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp63_ = self->priv->undo_history[_tmp61_];
#line 178 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp64_ = self->priv->undo_index;
#line 178 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		self->priv->undo_index = _tmp64_ + 1;
#line 1410 "game.c"
	}
#line 181 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = n_flips;
#line 181 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 1416 "game.c"
}


gint game_count_tiles (Game* self, Player color) {
	gint result = 0;
	gint count = 0;
#line 184 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 186 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	count = 0;
#line 1427 "game.c"
	{
		gint x = 0;
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		x = 0;
#line 1432 "game.c"
		{
			gboolean _tmp0_ = FALSE;
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			_tmp0_ = TRUE;
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			while (TRUE) {
#line 1439 "game.c"
				gboolean _tmp1_ = FALSE;
				gint _tmp3_ = 0;
				gint _tmp4_ = 0;
				gint _tmp5_ = 0;
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp1_ = _tmp0_;
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!_tmp1_) {
#line 1448 "game.c"
					gint _tmp2_ = 0;
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp2_ = x;
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					x = _tmp2_ + 1;
#line 1454 "game.c"
				}
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp0_ = FALSE;
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp3_ = x;
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp4_ = game_get_width (self);
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp5_ = _tmp4_;
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!(_tmp3_ < _tmp5_)) {
#line 187 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					break;
#line 1468 "game.c"
				}
				{
					gint y = 0;
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					y = 0;
#line 1474 "game.c"
					{
						gboolean _tmp6_ = FALSE;
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						_tmp6_ = TRUE;
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						while (TRUE) {
#line 1481 "game.c"
							gboolean _tmp7_ = FALSE;
							gint _tmp9_ = 0;
							gint _tmp10_ = 0;
							gint _tmp11_ = 0;
							Player* _tmp12_ = NULL;
							gint _tmp12__length1 = 0;
							gint _tmp12__length2 = 0;
							gint _tmp13_ = 0;
							gint _tmp14_ = 0;
							Player _tmp15_ = 0;
							Player _tmp16_ = 0;
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp7_ = _tmp6_;
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!_tmp7_) {
#line 1497 "game.c"
								gint _tmp8_ = 0;
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								_tmp8_ = y;
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								y = _tmp8_ + 1;
#line 1503 "game.c"
							}
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp6_ = FALSE;
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp9_ = y;
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp10_ = game_get_height (self);
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp11_ = _tmp10_;
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!(_tmp9_ < _tmp11_)) {
#line 188 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								break;
#line 1517 "game.c"
							}
#line 189 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp12_ = self->priv->tiles;
#line 189 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp12__length1 = self->priv->tiles_length1;
#line 189 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp12__length2 = self->priv->tiles_length2;
#line 189 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp13_ = x;
#line 189 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp14_ = y;
#line 189 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp15_ = _tmp12_[(_tmp13_ * _tmp12__length2) + _tmp14_];
#line 189 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp16_ = color;
#line 189 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (_tmp15_ == _tmp16_) {
#line 1535 "game.c"
								gint _tmp17_ = 0;
#line 190 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								_tmp17_ = count;
#line 190 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								count = _tmp17_ + 1;
#line 1541 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 191 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = count;
#line 191 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 1553 "game.c"
}


static gboolean game_is_valid_location (Game* self, gint x, gint y) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_ = 0;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp13_ = FALSE;
#line 194 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp3_ = x;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp3_ >= 0) {
#line 1572 "game.c"
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp4_ = x;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp5_ = game_get_width (self);
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp6_ = _tmp5_;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp2_ = _tmp4_ < _tmp6_;
#line 1584 "game.c"
	} else {
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp2_ = FALSE;
#line 1588 "game.c"
	}
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp7_ = _tmp2_;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp7_) {
#line 1594 "game.c"
		gint _tmp8_ = 0;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp8_ = y;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp1_ = _tmp8_ >= 0;
#line 1600 "game.c"
	} else {
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp1_ = FALSE;
#line 1604 "game.c"
	}
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp9_ = _tmp1_;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp9_) {
#line 1610 "game.c"
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp10_ = y;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp11_ = game_get_height (self);
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp12_ = _tmp11_;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp0_ = _tmp10_ < _tmp12_;
#line 1622 "game.c"
	} else {
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp0_ = FALSE;
#line 1626 "game.c"
	}
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp13_ = _tmp0_;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = _tmp13_;
#line 196 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 1634 "game.c"
}


static gint game_flip_tiles (Game* self, gint x, gint y, gint x_step, gint y_step, Player color, gboolean apply) {
	gint result = 0;
	Player enemy = 0;
	Player _tmp0_ = 0;
	gint enemy_count = 0;
	gint xt = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint yt = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gint _tmp20_ = 0;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
#line 199 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 201 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	enemy = PLAYER_LIGHT;
#line 202 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = color;
#line 202 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp0_ == PLAYER_LIGHT) {
#line 203 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		enemy = PLAYER_DARK;
#line 1665 "game.c"
	}
#line 206 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	enemy_count = 0;
#line 207 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = x;
#line 207 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = x_step;
#line 207 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	xt = _tmp1_ + _tmp2_;
#line 208 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp3_ = y;
#line 208 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp4_ = y_step;
#line 208 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	yt = _tmp3_ + _tmp4_;
#line 209 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	while (TRUE) {
#line 1683 "game.c"
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		gboolean _tmp7_ = FALSE;
		Player* _tmp8_ = NULL;
		gint _tmp8__length1 = 0;
		gint _tmp8__length2 = 0;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		Player _tmp11_ = 0;
		Player _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gint _tmp17_ = 0;
#line 209 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp5_ = xt;
#line 209 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp6_ = yt;
#line 209 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp7_ = game_is_valid_location (self, _tmp5_, _tmp6_);
#line 209 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		if (!_tmp7_) {
#line 209 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			break;
#line 1709 "game.c"
		}
#line 211 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp8_ = self->priv->tiles;
#line 211 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp8__length1 = self->priv->tiles_length1;
#line 211 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp8__length2 = self->priv->tiles_length2;
#line 211 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp9_ = xt;
#line 211 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp10_ = yt;
#line 211 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp11_ = _tmp8_[(_tmp9_ * _tmp8__length2) + _tmp10_];
#line 211 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp12_ = enemy;
#line 211 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		if (_tmp11_ != _tmp12_) {
#line 212 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			break;
#line 1729 "game.c"
		}
#line 213 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp13_ = enemy_count;
#line 213 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		enemy_count = _tmp13_ + 1;
#line 214 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp14_ = xt;
#line 214 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp15_ = x_step;
#line 214 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		xt = _tmp14_ + _tmp15_;
#line 215 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp16_ = yt;
#line 215 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp17_ = y_step;
#line 215 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		yt = _tmp16_ + _tmp17_;
#line 1747 "game.c"
	}
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp20_ = enemy_count;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp20_ == 0) {
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp19_ = TRUE;
#line 1755 "game.c"
	} else {
		gint _tmp21_ = 0;
		gint _tmp22_ = 0;
		gboolean _tmp23_ = FALSE;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp21_ = xt;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp22_ = yt;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp23_ = game_is_valid_location (self, _tmp21_, _tmp22_);
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp19_ = !_tmp23_;
#line 1768 "game.c"
	}
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp24_ = _tmp19_;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp24_) {
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp18_ = TRUE;
#line 1776 "game.c"
	} else {
		Player* _tmp25_ = NULL;
		gint _tmp25__length1 = 0;
		gint _tmp25__length2 = 0;
		gint _tmp26_ = 0;
		gint _tmp27_ = 0;
		Player _tmp28_ = 0;
		Player _tmp29_ = 0;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp25_ = self->priv->tiles;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp25__length1 = self->priv->tiles_length1;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp25__length2 = self->priv->tiles_length2;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp26_ = xt;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp27_ = yt;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp28_ = _tmp25_[(_tmp26_ * _tmp25__length2) + _tmp27_];
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp29_ = color;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp18_ = _tmp28_ != _tmp29_;
#line 1801 "game.c"
	}
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp30_ = _tmp18_;
#line 219 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp30_) {
#line 220 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		result = 0;
#line 220 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		return result;
#line 1811 "game.c"
	}
#line 223 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp31_ = apply;
#line 223 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp31_) {
#line 1817 "game.c"
		{
			gint i = 0;
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			i = 0;
#line 1822 "game.c"
			{
				gboolean _tmp32_ = FALSE;
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp32_ = TRUE;
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				while (TRUE) {
#line 1829 "game.c"
					gboolean _tmp33_ = FALSE;
					gint _tmp35_ = 0;
					gint _tmp36_ = 0;
					gint _tmp37_ = 0;
					gint _tmp38_ = 0;
					gint _tmp39_ = 0;
					gint _tmp40_ = 0;
					gint _tmp41_ = 0;
					gint _tmp42_ = 0;
					Player _tmp43_ = 0;
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp33_ = _tmp32_;
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					if (!_tmp33_) {
#line 1844 "game.c"
						gint _tmp34_ = 0;
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						_tmp34_ = i;
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						i = _tmp34_ + 1;
#line 1850 "game.c"
					}
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp32_ = FALSE;
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp35_ = i;
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp36_ = enemy_count;
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					if (!(_tmp35_ <= _tmp36_)) {
#line 224 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						break;
#line 1862 "game.c"
					}
#line 225 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp37_ = x;
#line 225 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp38_ = i;
#line 225 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp39_ = x_step;
#line 225 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp40_ = y;
#line 225 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp41_ = i;
#line 225 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp42_ = y_step;
#line 225 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp43_ = color;
#line 225 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					game_set_tile (self, _tmp37_ + (_tmp38_ * _tmp39_), _tmp40_ + (_tmp41_ * _tmp42_), _tmp43_, TRUE);
#line 1880 "game.c"
				}
			}
		}
	}
#line 227 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = enemy_count;
#line 227 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 1889 "game.c"
}


gboolean game_can_undo (Game* self) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
#line 230 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 232 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = self->priv->undo_index;
#line 232 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = _tmp0_ > 0;
#line 232 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 1904 "game.c"
}


void game_undo (Game* self, gint count) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
#line 235 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_if_fail (self != NULL);
#line 235 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = count;
#line 235 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = count;
#line 235 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_if_fail ((_tmp0_ == 1) || (_tmp1_ == 2));
#line 238 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = game_can_undo (self);
#line 238 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (!_tmp2_) {
#line 239 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		return;
#line 1926 "game.c"
	}
	{
		gint i = 0;
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		i = 0;
#line 1932 "game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			_tmp3_ = TRUE;
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			while (TRUE) {
#line 1939 "game.c"
				gboolean _tmp4_ = FALSE;
				gint _tmp6_ = 0;
				gint _tmp7_ = 0;
				gint n_changes = 0;
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				Player _tmp28_ = 0;
				Player _tmp29_ = 0;
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp4_ = _tmp3_;
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!_tmp4_) {
#line 1953 "game.c"
					gint _tmp5_ = 0;
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp5_ = i;
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					i = _tmp5_ + 1;
#line 1959 "game.c"
				}
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp3_ = FALSE;
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp6_ = i;
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp7_ = count;
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!(_tmp6_ < _tmp7_)) {
#line 241 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					break;
#line 1971 "game.c"
				}
#line 243 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp8_ = self->priv->undo_index;
#line 243 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp9_ = self->priv->undo_history[_tmp8_ - 1];
#line 243 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				n_changes = _tmp9_;
#line 244 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp10_ = self->priv->undo_index;
#line 244 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				self->priv->undo_index = _tmp10_ - 1;
#line 1983 "game.c"
				{
					gint j = 0;
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					j = 0;
#line 1988 "game.c"
					{
						gboolean _tmp11_ = FALSE;
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						_tmp11_ = TRUE;
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						while (TRUE) {
#line 1995 "game.c"
							gboolean _tmp12_ = FALSE;
							gint _tmp14_ = 0;
							gint _tmp15_ = 0;
							gint n = 0;
							gint _tmp16_ = 0;
							gint _tmp17_ = 0;
							gint _tmp18_ = 0;
							Player c = 0;
							gint _tmp19_ = 0;
							gint xy = 0;
							gint _tmp20_ = 0;
							gint _tmp21_ = 0;
							gint _tmp22_ = 0;
							gint _tmp23_ = 0;
							gint _tmp24_ = 0;
							gint _tmp25_ = 0;
							gint _tmp26_ = 0;
							Player _tmp27_ = 0;
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp12_ = _tmp11_;
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!_tmp12_) {
#line 2018 "game.c"
								gint _tmp13_ = 0;
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								_tmp13_ = j;
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								j = _tmp13_ + 1;
#line 2024 "game.c"
							}
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp11_ = FALSE;
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp14_ = j;
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp15_ = n_changes;
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!(_tmp14_ < _tmp15_)) {
#line 247 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								break;
#line 2036 "game.c"
							}
#line 249 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp16_ = self->priv->undo_index;
#line 249 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp17_ = self->priv->undo_history[_tmp16_ - 1];
#line 249 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							n = _tmp17_;
#line 250 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp18_ = self->priv->undo_index;
#line 250 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							self->priv->undo_index = _tmp18_ - 1;
#line 251 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp19_ = n;
#line 251 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							c = (Player) (_tmp19_ >> 6);
#line 252 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp20_ = n;
#line 252 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							xy = _tmp20_ & 0x3F;
#line 253 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp21_ = xy;
#line 253 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp22_ = game_get_width (self);
#line 253 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp23_ = _tmp22_;
#line 253 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp24_ = xy;
#line 253 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp25_ = game_get_width (self);
#line 253 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp26_ = _tmp25_;
#line 253 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp27_ = c;
#line 253 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							game_set_tile (self, _tmp21_ % _tmp23_, _tmp24_ / _tmp26_, _tmp27_, FALSE);
#line 2072 "game.c"
						}
					}
				}
#line 257 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp28_ = self->priv->_current_color;
#line 257 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp29_ = player_flip_color (_tmp28_);
#line 257 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				game_set_current_color (self, _tmp29_);
#line 2082 "game.c"
			}
		}
	}
}


static void game_set_tile (Game* self, gint x, gint y, Player color, gboolean update_history) {
	Player* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	Player _tmp3_ = 0;
	Player _tmp4_ = 0;
	gboolean _tmp5_ = FALSE;
	Player* _tmp17_ = NULL;
	gint _tmp17__length1 = 0;
	gint _tmp17__length2 = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	Player _tmp20_ = 0;
	Player _tmp21_ = 0;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
#line 261 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_if_fail (self != NULL);
#line 263 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 263 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 263 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 263 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = x;
#line 263 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = y;
#line 263 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 263 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp4_ = color;
#line 263 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp3_ == _tmp4_) {
#line 264 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		return;
#line 2127 "game.c"
	}
#line 267 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp5_ = update_history;
#line 267 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (_tmp5_) {
#line 2133 "game.c"
		gint _tmp6_ = 0;
		Player* _tmp7_ = NULL;
		gint _tmp7__length1 = 0;
		gint _tmp7__length2 = 0;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		Player _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp6_ = self->priv->undo_index;
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp7_ = self->priv->tiles;
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp7__length1 = self->priv->tiles_length1;
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp7__length2 = self->priv->tiles_length2;
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp8_ = x;
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp9_ = y;
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp10_ = _tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_];
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp11_ = y;
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp12_ = game_get_width (self);
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp13_ = _tmp12_;
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp14_ = x;
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		self->priv->undo_history[_tmp6_] = (((gint) _tmp10_) << 6) | ((_tmp11_ * _tmp13_) + _tmp14_);
#line 269 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp15_ = self->priv->undo_history[_tmp6_];
#line 270 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		_tmp16_ = self->priv->undo_index;
#line 270 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		self->priv->undo_index = _tmp16_ + 1;
#line 2177 "game.c"
	}
#line 273 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp17_ = self->priv->tiles;
#line 273 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp17__length1 = self->priv->tiles_length1;
#line 273 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp17__length2 = self->priv->tiles_length2;
#line 273 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp18_ = x;
#line 273 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp19_ = y;
#line 273 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp20_ = color;
#line 273 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp17_[(_tmp18_ * _tmp17__length2) + _tmp19_] = _tmp20_;
#line 273 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp21_ = _tmp17_[(_tmp18_ * _tmp17__length2) + _tmp19_];
#line 274 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp22_ = x;
#line 274 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp23_ = y;
#line 274 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_signal_emit_by_name (self, "square-changed", _tmp22_, _tmp23_);
#line 2201 "game.c"
}


gchar* game_to_string (Game* self) {
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_ = NULL;
#line 277 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 279 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = g_strdup ("\n");
#line 279 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	s = _tmp0_;
#line 2215 "game.c"
	{
		gint y = 0;
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		y = 0;
#line 2220 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			_tmp1_ = TRUE;
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
			while (TRUE) {
#line 2227 "game.c"
				gboolean _tmp2_ = FALSE;
				gint _tmp4_ = 0;
				gint _tmp5_ = 0;
				gint _tmp6_ = 0;
				const gchar* _tmp21_ = NULL;
				gchar* _tmp22_ = NULL;
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp2_ = _tmp1_;
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!_tmp2_) {
#line 2238 "game.c"
					gint _tmp3_ = 0;
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					_tmp3_ = y;
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					y = _tmp3_ + 1;
#line 2244 "game.c"
				}
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp1_ = FALSE;
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp4_ = y;
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp5_ = game_get_height (self);
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp6_ = _tmp5_;
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				if (!(_tmp4_ < _tmp6_)) {
#line 281 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					break;
#line 2258 "game.c"
				}
				{
					gint x = 0;
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
					x = 0;
#line 2264 "game.c"
					{
						gboolean _tmp7_ = FALSE;
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						_tmp7_ = TRUE;
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
						while (TRUE) {
#line 2271 "game.c"
							gboolean _tmp8_ = FALSE;
							gint _tmp10_ = 0;
							gint _tmp11_ = 0;
							gint _tmp12_ = 0;
							const gchar* _tmp13_ = NULL;
							Player* _tmp14_ = NULL;
							gint _tmp14__length1 = 0;
							gint _tmp14__length2 = 0;
							gint _tmp15_ = 0;
							gint _tmp16_ = 0;
							Player _tmp17_ = 0;
							gchar* _tmp18_ = NULL;
							gchar* _tmp19_ = NULL;
							gchar* _tmp20_ = NULL;
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp8_ = _tmp7_;
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!_tmp8_) {
#line 2290 "game.c"
								gint _tmp9_ = 0;
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								_tmp9_ = x;
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								x = _tmp9_ + 1;
#line 2296 "game.c"
							}
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp7_ = FALSE;
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp10_ = x;
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp11_ = game_get_width (self);
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp12_ = _tmp11_;
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							if (!(_tmp10_ < _tmp12_)) {
#line 283 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
								break;
#line 2310 "game.c"
							}
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp13_ = s;
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp14_ = self->priv->tiles;
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp14__length1 = self->priv->tiles_length1;
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp14__length2 = self->priv->tiles_length2;
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp15_ = x;
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp16_ = y;
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp17_ = _tmp14_[(_tmp15_ * _tmp14__length2) + _tmp16_];
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp18_ = player_to_string (_tmp17_);
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp19_ = _tmp18_;
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_tmp20_ = g_strconcat (_tmp13_, _tmp19_, NULL);
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_g_free0 (s);
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							s = _tmp20_;
#line 284 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
							_g_free0 (_tmp19_);
#line 2338 "game.c"
						}
					}
				}
#line 285 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp21_ = s;
#line 285 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_tmp22_ = g_strconcat (_tmp21_, "\n", NULL);
#line 285 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				_g_free0 (s);
#line 285 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
				s = _tmp22_;
#line 2350 "game.c"
			}
		}
	}
#line 288 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = s;
#line 288 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 2358 "game.c"
}


gint game_get_width (Game* self) {
	gint result;
	Player* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint _tmp1_ = 0;
#line 18 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 18 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 18 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 18 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 18 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = _tmp0__length1;
#line 18 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = _tmp1_;
#line 18 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 2382 "game.c"
}


gint game_get_height (Game* self) {
	gint result;
	Player* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint _tmp1_ = 0;
#line 23 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 23 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 23 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 23 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 23 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = _tmp0__length2;
#line 23 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = _tmp1_;
#line 23 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 2406 "game.c"
}


Player game_get_current_color (Game* self) {
	Player result;
	Player _tmp0_ = 0;
#line 35 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = self->priv->_current_color;
#line 35 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = _tmp0_;
#line 35 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 2421 "game.c"
}


static void game_set_current_color (Game* self, Player value) {
	Player _tmp0_ = 0;
#line 35 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_if_fail (self != NULL);
#line 35 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = value;
#line 35 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->_current_color = _tmp0_;
#line 35 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_object_notify ((GObject *) self, "current-color");
#line 2435 "game.c"
}


gint game_get_n_tiles (Game* self) {
	gint result;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
#line 49 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 49 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = game_get_n_light_tiles (self);
#line 49 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp1_ = _tmp0_;
#line 49 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp2_ = game_get_n_dark_tiles (self);
#line 49 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp3_ = _tmp2_;
#line 49 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = _tmp1_ + _tmp3_;
#line 49 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 2459 "game.c"
}


gint game_get_n_light_tiles (Game* self) {
	gint result;
	gint _tmp0_ = 0;
#line 54 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 54 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = game_count_tiles (self, PLAYER_LIGHT);
#line 54 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = _tmp0_;
#line 54 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 2474 "game.c"
}


gint game_get_n_dark_tiles (Game* self) {
	gint result;
	gint _tmp0_ = 0;
#line 59 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 59 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	_tmp0_ = game_count_tiles (self, PLAYER_DARK);
#line 59 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	result = _tmp0_;
#line 59 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	return result;
#line 2489 "game.c"
}


static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_return_if_fail (n_param_values == 3);
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		data1 = closure->data;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 2508 "game.c"
	} else {
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		data2 = closure->data;
#line 2514 "game.c"
	}
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 2520 "game.c"
}


static void game_class_init (GameClass * klass) {
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_type_class_add_private (klass, sizeof (GamePrivate));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_WIDTH, g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HEIGHT, g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_COLOR, g_param_spec_enum ("current-color", "current-color", "current-color", TYPE_PLAYER, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_TILES, g_param_spec_int ("n-tiles", "n-tiles", "n-tiles", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_LIGHT_TILES, g_param_spec_int ("n-light-tiles", "n-light-tiles", "n-light-tiles", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_DARK_TILES, g_param_spec_int ("n-dark-tiles", "n-dark-tiles", "n-dark-tiles", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_signal_new ("move", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_signal_new ("square_changed", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	g_signal_new ("complete", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2553 "game.c"
}


static void game_instance_init (Game * self) {
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv = GAME_GET_PRIVATE (self);
#line 32 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->undo_index = 0;
#line 2562 "game.c"
}


static void game_finalize (GObject* obj) {
	Game * self;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 14 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	self->priv->tiles = (g_free (self->priv->tiles), NULL);
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 2574 "game.c"
}


GType game_get_type (void) {
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}


static void _vala_game_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	switch (property_id) {
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		case GAME_WIDTH:
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		g_value_set_int (value, game_get_width (self));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		break;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		case GAME_HEIGHT:
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		g_value_set_int (value, game_get_height (self));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		break;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		case GAME_CURRENT_COLOR:
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		g_value_set_enum (value, game_get_current_color (self));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		break;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		case GAME_N_TILES:
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		g_value_set_int (value, game_get_n_tiles (self));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		break;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		case GAME_N_LIGHT_TILES:
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		g_value_set_int (value, game_get_n_light_tiles (self));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		break;
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		case GAME_N_DARK_TILES:
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		g_value_set_int (value, game_get_n_dark_tiles (self));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		break;
#line 2631 "game.c"
		default:
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		break;
#line 2637 "game.c"
	}
}


static void _vala_game_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
	switch (property_id) {
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		case GAME_CURRENT_COLOR:
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		game_set_current_color (self, g_value_get_enum (value));
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		break;
#line 2653 "game.c"
		default:
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 11 "/home/mcatanzaro/jhbuild/src/iagno/src/game.vala"
		break;
#line 2659 "game.c"
	}
}



